from cymem.cymem cimport Pool

from .structs cimport TokenC
from .typedefs cimport flags_t

from .syntax.transition_system cimport Transition

cimport numpy


cdef struct GoldParseC:
    int* tags
    int* heads
    int* labels
    flags_t* ssenses
    int** brackets
    Transition* ner


cdef class GoldParse:
    cdef Pool mem

    cdef GoldParseC c

    cdef int length
    cdef readonly int loss
    cdef readonly list tags
    cdef readonly list heads
    cdef readonly list labels
    cdef readonly dict orths
    cdef readonly list ssenses
    cdef readonly list ner
    cdef readonly list ents
    cdef readonly dict brackets

    cdef readonly list cand_to_gold
    cdef readonly list gold_to_cand
    cdef readonly list orig_annot


